Package org.opencv.calib3d

## Class StereoSGBM

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.calib3d.StereoMatcher
    - - org.opencv.calib3d.StereoSGBM

-     public class StereoSGBM
      extends StereoMatcher

  The class implements the modified H. Hirschmuller algorithm CITE: HH08 that differs from the original one as follows:
  - By default, the algorithm is single-pass, which means that you consider only 5 directions instead of 8. Set mode=StereoSGBM::MODE_HH in createStereoSGBM to run the full variant of the algorithm but beware that it may consume a lot of memory.
  - The algorithm matches blocks, not individual pixels. Though, setting blockSize=1 reduces the blocks to single pixels.
  - Mutual information cost function is not implemented. Instead, a simpler Birchfield-Tomasi sub-pixel metric from CITE: BT98 is used. Though, the color images are supported as well.
  - Some pre- and post- processing steps from K. Konolige algorithm StereoBM are included, for example: pre-filtering (StereoBM::PREFILTER_XSOBEL type) and post-filtering (uniqueness check, quadratic interpolation and speckle filtering).
  Note:
  - (Python) An example illustrating the use of the StereoSGBM matching algorithm can be found at opencv_source_code/samples/python/stereo_match.py

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `MODE_HH` |
    `static int` | `MODE_HH4` |
    `static int` | `MODE_SGBM` |
    `static int` | `MODE_SGBM_3WAY` |

    - ### Fields inherited from class org.opencv.calib3d.StereoMatcher

      `DISP_SCALE, DISP_SHIFT`

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `StereoSGBM​(long addr)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static StereoSGBM` | `__fromPtr__​(long addr)` |
    `static StereoSGBM` | `create()` | Creates StereoSGBM object rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
    `static StereoSGBM` | `create​(int minDisparity)` | Creates StereoSGBM object
    `static StereoSGBM` | `create​(int minDisparity, int numDisparities)` | Creates StereoSGBM object
    `static StereoSGBM` | `create​(int minDisparity, int numDisparities, int blockSize)` | Creates StereoSGBM object
    `static StereoSGBM` | `create​(int minDisparity, int numDisparities, int blockSize, int P1)` | Creates StereoSGBM object
    `static StereoSGBM` | `create​(int minDisparity, int numDisparities, int blockSize, int P1, int P2)` | Creates StereoSGBM object
    `static StereoSGBM` | `create​(int minDisparity, int numDisparities, int blockSize, int P1, int P2, int disp12MaxDiff)` | Creates StereoSGBM object
    `static StereoSGBM` | `create​(int minDisparity, int numDisparities, int blockSize, int P1, int P2, int disp12MaxDiff, int preFilterCap)` | Creates StereoSGBM object
    `static StereoSGBM` | `create​(int minDisparity, int numDisparities, int blockSize, int P1, int P2, int disp12MaxDiff, int preFilterCap, int uniquenessRatio)` | Creates StereoSGBM object
    `static StereoSGBM` | `create​(int minDisparity, int numDisparities, int blockSize, int P1, int P2, int disp12MaxDiff, int preFilterCap, int uniquenessRatio, int speckleWindowSize)` | Creates StereoSGBM object
    `static StereoSGBM` | `create​(int minDisparity, int numDisparities, int blockSize, int P1, int P2, int disp12MaxDiff, int preFilterCap, int uniquenessRatio, int speckleWindowSize, int speckleRange)` | Creates StereoSGBM object
    `static StereoSGBM` | `create​(int minDisparity, int numDisparities, int blockSize, int P1, int P2, int disp12MaxDiff, int preFilterCap, int uniquenessRatio, int speckleWindowSize, int speckleRange, int mode)` | Creates StereoSGBM object
    `protected void` | `finalize()` |
    `int` | `getMode()` |
    `int` | `getP1()` |
    `int` | `getP2()` |
    `int` | `getPreFilterCap()` |
    `int` | `getUniquenessRatio()` |
    `void` | `setMode​(int mode)` |
    `void` | `setP1​(int P1)` |
    `void` | `setP2​(int P2)` |
    `void` | `setPreFilterCap​(int preFilterCap)` |
    `void` | `setUniquenessRatio​(int uniquenessRatio)` |

    - ### Methods inherited from class org.opencv.calib3d.StereoMatcher

      `compute, getBlockSize, getDisp12MaxDiff, getMinDisparity, getNumDisparities, getSpeckleRange, getSpeckleWindowSize, setBlockSize, setDisp12MaxDiff, setMinDisparity, setNumDisparities, setSpeckleRange, setSpeckleWindowSize`

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, empty, getDefaultName, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### MODE_SGBM

          public static final int MODE_SGBM

      See Also:
        Constant Field Values

    - #### MODE_HH

          public static final int MODE_HH

      See Also:
        Constant Field Values

    - #### MODE_SGBM_3WAY

          public static final int MODE_SGBM_3WAY

      See Also:
        Constant Field Values

    - #### MODE_HH4

          public static final int MODE_HH4

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### StereoSGBM

          protected StereoSGBM​(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static StereoSGBM __fromPtr__​(long addr)

    - #### create

          public static StereoSGBM create​(int minDisparity,
                                          int numDisparities,
                                          int blockSize,
                                          int P1,
                                          int P2,
                                          int disp12MaxDiff,
                                          int preFilterCap,
                                          int uniquenessRatio,
                                          int speckleWindowSize,
                                          int speckleRange,
                                          int mode)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
        `numDisparities` - Maximum disparity minus minimum disparity. The value is always greater than zero. In the current implementation, this parameter must be divisible by 16.
        `blockSize` - Matched block size. It must be an odd number >=1 . Normally, it should be somewhere in the 3..11 range.
        `P1` - The first parameter controlling the disparity smoothness. See below.
        `P2` - The second parameter controlling the disparity smoothness. The larger the values are, the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively).
        `disp12MaxDiff` - Maximum allowed difference (in integer pixel units) in the left-right disparity check. Set it to a non-positive value to disable the check.
        `preFilterCap` - Truncation value for the prefiltered image pixels. The algorithm first computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function.
        `uniquenessRatio` - Margin in percentage by which the best (minimum) computed cost function value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough.
        `speckleWindowSize` - Maximum size of smooth disparity regions to consider their noise speckles and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range.
        `speckleRange` - Maximum disparity variation within each connected component. If you do speckle filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough.
        `mode` - Set it to StereoSGBM::MODE_HH to run the full-scale two-pass dynamic programming algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create​(int minDisparity,
                                          int numDisparities,
                                          int blockSize,
                                          int P1,
                                          int P2,
                                          int disp12MaxDiff,
                                          int preFilterCap,
                                          int uniquenessRatio,
                                          int speckleWindowSize,
                                          int speckleRange)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
        `numDisparities` - Maximum disparity minus minimum disparity. The value is always greater than zero. In the current implementation, this parameter must be divisible by 16.
        `blockSize` - Matched block size. It must be an odd number >=1 . Normally, it should be somewhere in the 3..11 range.
        `P1` - The first parameter controlling the disparity smoothness. See below.
        `P2` - The second parameter controlling the disparity smoothness. The larger the values are, the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively).
        `disp12MaxDiff` - Maximum allowed difference (in integer pixel units) in the left-right disparity check. Set it to a non-positive value to disable the check.
        `preFilterCap` - Truncation value for the prefiltered image pixels. The algorithm first computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function.
        `uniquenessRatio` - Margin in percentage by which the best (minimum) computed cost function value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough.
        `speckleWindowSize` - Maximum size of smooth disparity regions to consider their noise speckles and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range.
        `speckleRange` - Maximum disparity variation within each connected component. If you do speckle filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create​(int minDisparity,
                                          int numDisparities,
                                          int blockSize,
                                          int P1,
                                          int P2,
                                          int disp12MaxDiff,
                                          int preFilterCap,
                                          int uniquenessRatio,
                                          int speckleWindowSize)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
        `numDisparities` - Maximum disparity minus minimum disparity. The value is always greater than zero. In the current implementation, this parameter must be divisible by 16.
        `blockSize` - Matched block size. It must be an odd number >=1 . Normally, it should be somewhere in the 3..11 range.
        `P1` - The first parameter controlling the disparity smoothness. See below.
        `P2` - The second parameter controlling the disparity smoothness. The larger the values are, the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively).
        `disp12MaxDiff` - Maximum allowed difference (in integer pixel units) in the left-right disparity check. Set it to a non-positive value to disable the check.
        `preFilterCap` - Truncation value for the prefiltered image pixels. The algorithm first computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function.
        `uniquenessRatio` - Margin in percentage by which the best (minimum) computed cost function value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough.
        `speckleWindowSize` - Maximum size of smooth disparity regions to consider their noise speckles and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range. filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create​(int minDisparity,
                                          int numDisparities,
                                          int blockSize,
                                          int P1,
                                          int P2,
                                          int disp12MaxDiff,
                                          int preFilterCap,
                                          int uniquenessRatio)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
        `numDisparities` - Maximum disparity minus minimum disparity. The value is always greater than zero. In the current implementation, this parameter must be divisible by 16.
        `blockSize` - Matched block size. It must be an odd number >=1 . Normally, it should be somewhere in the 3..11 range.
        `P1` - The first parameter controlling the disparity smoothness. See below.
        `P2` - The second parameter controlling the disparity smoothness. The larger the values are, the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively).
        `disp12MaxDiff` - Maximum allowed difference (in integer pixel units) in the left-right disparity check. Set it to a non-positive value to disable the check.
        `preFilterCap` - Truncation value for the prefiltered image pixels. The algorithm first computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function.
        `uniquenessRatio` - Margin in percentage by which the best (minimum) computed cost function value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough. and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range. filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create​(int minDisparity,
                                          int numDisparities,
                                          int blockSize,
                                          int P1,
                                          int P2,
                                          int disp12MaxDiff,
                                          int preFilterCap)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
        `numDisparities` - Maximum disparity minus minimum disparity. The value is always greater than zero. In the current implementation, this parameter must be divisible by 16.
        `blockSize` - Matched block size. It must be an odd number >=1 . Normally, it should be somewhere in the 3..11 range.
        `P1` - The first parameter controlling the disparity smoothness. See below.
        `P2` - The second parameter controlling the disparity smoothness. The larger the values are, the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively).
        `disp12MaxDiff` - Maximum allowed difference (in integer pixel units) in the left-right disparity check. Set it to a non-positive value to disable the check.
        `preFilterCap` - Truncation value for the prefiltered image pixels. The algorithm first computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function. value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough. and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range. filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create​(int minDisparity,
                                          int numDisparities,
                                          int blockSize,
                                          int P1,
                                          int P2,
                                          int disp12MaxDiff)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
        `numDisparities` - Maximum disparity minus minimum disparity. The value is always greater than zero. In the current implementation, this parameter must be divisible by 16.
        `blockSize` - Matched block size. It must be an odd number >=1 . Normally, it should be somewhere in the 3..11 range.
        `P1` - The first parameter controlling the disparity smoothness. See below.
        `P2` - The second parameter controlling the disparity smoothness. The larger the values are, the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively).
        `disp12MaxDiff` - Maximum allowed difference (in integer pixel units) in the left-right disparity check. Set it to a non-positive value to disable the check. computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function. value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough. and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range. filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create​(int minDisparity,
                                          int numDisparities,
                                          int blockSize,
                                          int P1,
                                          int P2)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
        `numDisparities` - Maximum disparity minus minimum disparity. The value is always greater than zero. In the current implementation, this parameter must be divisible by 16.
        `blockSize` - Matched block size. It must be an odd number >=1 . Normally, it should be somewhere in the 3..11 range.
        `P1` - The first parameter controlling the disparity smoothness. See below.
        `P2` - The second parameter controlling the disparity smoothness. The larger the values are, the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively). disparity check. Set it to a non-positive value to disable the check. computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function. value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough. and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range. filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create​(int minDisparity,
                                          int numDisparities,
                                          int blockSize,
                                          int P1)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
        `numDisparities` - Maximum disparity minus minimum disparity. The value is always greater than zero. In the current implementation, this parameter must be divisible by 16.
        `blockSize` - Matched block size. It must be an odd number >=1 . Normally, it should be somewhere in the 3..11 range.
        `P1` - The first parameter controlling the disparity smoothness. See below. the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively). disparity check. Set it to a non-positive value to disable the check. computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function. value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough. and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range. filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create​(int minDisparity,
                                          int numDisparities,
                                          int blockSize)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
        `numDisparities` - Maximum disparity minus minimum disparity. The value is always greater than zero. In the current implementation, this parameter must be divisible by 16.
        `blockSize` - Matched block size. It must be an odd number >=1 . Normally, it should be somewhere in the 3..11 range. the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively). disparity check. Set it to a non-positive value to disable the check. computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function. value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough. and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range. filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create​(int minDisparity,
                                          int numDisparities)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly.
        `numDisparities` - Maximum disparity minus minimum disparity. The value is always greater than zero. In the current implementation, this parameter must be divisible by 16. somewhere in the 3..11 range. the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively). disparity check. Set it to a non-positive value to disable the check. computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function. value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough. and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range. filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create​(int minDisparity)

      Creates StereoSGBM object
      Parameters:
        `minDisparity` - Minimum possible disparity value. Normally, it is zero but sometimes rectification algorithms can shift images, so this parameter needs to be adjusted accordingly. zero. In the current implementation, this parameter must be divisible by 16. somewhere in the 3..11 range. the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively). disparity check. Set it to a non-positive value to disable the check. computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function. value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough. and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range. filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### create

          public static StereoSGBM create()

      Creates StereoSGBM object rectification algorithms can shift images, so this parameter needs to be adjusted accordingly. zero. In the current implementation, this parameter must be divisible by 16. somewhere in the 3..11 range. the smoother the disparity is. P1 is the penalty on the disparity change by plus or minus 1 between neighbor pixels. P2 is the penalty on the disparity change by more than 1 between neighbor pixels. The algorithm requires P2 > P1 . See stereo_match.cpp sample where some reasonably good P1 and P2 values are shown (like 8\*number_of_image_channels\*blockSize\*blockSize and 32\*number_of_image_channels\*blockSize\*blockSize , respectively). disparity check. Set it to a non-positive value to disable the check. computes x-derivative at each pixel and clips its value by [-preFilterCap, preFilterCap] interval. The result values are passed to the Birchfield-Tomasi pixel cost function. value should "win" the second best value to consider the found match correct. Normally, a value within the 5-15 range is good enough. and invalidate. Set it to 0 to disable speckle filtering. Otherwise, set it somewhere in the 50-200 range. filtering, set the parameter to a positive value, it will be implicitly multiplied by 16. Normally, 1 or 2 is good enough. algorithm. It will consume O(W\*H\*numDisparities) bytes, which is large for 640x480 stereo and huge for HD-size pictures. By default, it is set to false . The first constructor initializes StereoSGBM with all the default parameters. So, you only have to set StereoSGBM::numDisparities at minimum. The second constructor enables you to set each parameter to a custom value.
      Returns:
        automatically generated

    - #### getMode

          public int getMode()

    - #### getP1

          public int getP1()

    - #### getP2

          public int getP2()

    - #### getPreFilterCap

          public int getPreFilterCap()

    - #### getUniquenessRatio

          public int getUniquenessRatio()

    - #### setMode

          public void setMode​(int mode)

    - #### setP1

          public void setP1​(int P1)

    - #### setP2

          public void setP2​(int P2)

    - #### setPreFilterCap

          public void setPreFilterCap​(int preFilterCap)

    - #### setUniquenessRatio

          public void setUniquenessRatio​(int uniquenessRatio)

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `StereoMatcher`
      Throws:
        `java.lang.Throwable`